; Copyright  2004 Sebastian Pipping <webmaster@hartwork.org>

!define PRODUCT_NAME              "Direct Volume Control"
!define PRODUCT_VERSION           "0.96 BETA"
!define PRODUCT_SETUP             "foo_dirvol_096_setup.exe"
!define PRODUCT_UNUIST            "foo_dirvol_uninstall.exe"

!define PRODUCT_PUBLISHER         "HARTWORK PROJECT"
!define PRODUCT_WEBSITE           "http://www.hartwork.org"
!define PRODUCT_UNINST_KEY        "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"

SetCompressor lzma


!include "MUI.nsh"

!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\classic-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\classic-uninstall.ico"

!define MUI_INSTFILESPAGE_PROGRESSBAR  ; Old-school progressbar


; **********************************************************************************
; **  Instfiles page
; **********************************************************************************

!insertmacro MUI_PAGE_INSTFILES


; **********************************************************************************
; **  UNINST Instfile page
; **********************************************************************************

!insertmacro MUI_UNPAGE_INSTFILES


; Language files
!insertmacro MUI_LANGUAGE "English"

; Reserve files
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS



; **********************************************************************************
; **  General
; **********************************************************************************

Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "..\Binary\${PRODUCT_SETUP}"
InstallDir "$PROGRAMFILES\foobar2000"
BrandingText "${PRODUCT_WEBSITE}  "

InstallDirRegKey HKCU "Software\foobar2000" "InstallDir"
ShowInstDetails show
ShowUnInstDetails show



; **********************************************************************************
; **  INSTALL
; **********************************************************************************

Section -INSTALL
  SetOutPath "$INSTDIR\Components"

  File "..\Binary\foo_dirvol.dll"
  File "foo_dirvol_changelog.txt"
  WriteUninstaller "$INSTDIR\Components\${PRODUCT_UNUIST}"

  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\Components\${PRODUCT_UNUIST}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\foobar2000.exe"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEBSITE}"
  WriteRegStr HKLM "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"

SectionEnd



; **********************************************************************************
; **  UNINST
; **********************************************************************************

Section Uninstall

  TRY_1:
    ClearErrors
    Delete "$INSTDIR\foo_dirvol.dll"
    IfErrors 0 +2
      MessageBox MB_ICONEXCLAMATION|MB_RETRYCANCEL|MB_DEFBUTTON1 'Error deleting file:$\n$\t"$INSTDIR\foo_dirvol.dll"$\nHit retry to retry deleting this file or$\ncancel to skip this file' IDRETRY TRY_1

  TRY_2:
    ClearErrors
    Delete "$INSTDIR\foo_dirvol_changelog.txt"
    IfErrors 0 +2
      MessageBox MB_ICONEXCLAMATION|MB_RETRYCANCEL|MB_DEFBUTTON1 'Error deleting file:$\n$\t"$INSTDIR\foo_dirvol_changelog.txt"$\nHit retry to retry deleting this file or$\ncancel to skip this file' IDRETRY TRY_2

  TRY_3:
    ClearErrors
    Delete "$INSTDIR\${PRODUCT_UNUIST}"
    IfErrors 0 +2
      MessageBox MB_ICONEXCLAMATION|MB_RETRYCANCEL|MB_DEFBUTTON1 'Error deleting file:$\n$\t"$INSTDIR\${PRODUCT_UNUIST}"$\nHit retry to retry deleting this file or$\ncancel to skip this file' IDRETRY TRY_3
 
  DeleteRegKey HKLM "${PRODUCT_UNINST_KEY}"

SectionEnd



; **********************************************************************************
; **  UNINST Callbacks
; **********************************************************************************

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to completely remove $(^Name) and all of its components?" IDYES +2
    Abort

FunctionEnd
